/// Error definition 
//
use thiserror::Error;
use std::fmt;

// #[derive(Debug, Fail)]

#[derive(Error, Eq, PartialEq, Clone, Debug)]
pub enum DatabaseErrors {
//     #[fail(display = "{}. Reason: {}", 0, 1)]
    ConnectionFailed(String, String),
//     #[fail(display = "{}. Reason: {}", 0, 1)]
    PoolCreationFailed(String, String),
}
impl fmt::Display for DatabaseErrors {
	fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result {
		match self {
      DatabaseErrors::ConnectionFailed(s,t) => write!(f,"connection {}: {} ",s,t),
      DatabaseErrors::PoolCreationFailed(s,t) => write!(f,"pool {}: {} ",s,t),
		}
		//write!(f, "{:?}", self)
	}
}

/// Database Store Errors
#[derive(Error, Debug)]
pub enum DataStoreError {
    #[error("data store disconnected")]
    Disconnect(#[from] std::io::Error),
    #[error("the data for key `{0}` is not available")]
    Redaction(String),
    #[error("invalid header (expected {expected:?}, found {found:?})")]
    InvalidHeader {
        expected: String,
        found: String,
    },
    #[error("unknown data store error")]
    Unknown,
}
